import pandas as pd
import csv
import logging

keys= ['Variant group', 
       'product ID',
       'ean',
       'category',
       'title',
       'short description',
       'long description',
       'brand',
       'web price',
       'VAT',
       'weight',
       'width',
       'lenght',
       'height',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media',
       'media']

def readOldCSV(file, new_name):
    root = []
    variant_counter = 0
    df = pd.read_csv(file, delimiter = ';')
    products = df.to_dict('records')
    
    for prod in products:
        entry = {
            'Variant group': '', 
            'product ID': '', 
            'ean': '',
            'category': '', 
            'title': '', 
            'short description': '', 
            'long description': '', 
            'brand': '', 
            'web price': '', 
            'VAT': '', 
            'weight': '', 
            'width': '', 
            'lenght': '', 
            'height': '', 
            'media1': '', 
            'media2': '', 
            'media3': '', 
            'media4': '', 
            'media5': '', 
            'media6': '', 
            'media7': '', 
            'media8': '', 
            'media9': '', 
            'media10': '', 
            'media11': '', 
            'media12': '', 
            'media13': '', 
            'media14': '', 
        }
        
        entry['Variant group'] = variant_counter
        variant_counter += 1
        
        entry['product ID'] = prod['SKU']
        
        entry['web price'] = prod['Cena końcowa w walucie platformy']
        
        entry['ean'] = prod['EAN']
        
        entry['category'] = prod['Kategoria']
        
        entry['title'] = prod['Nazwa produktu']
        
        counter = 1
        for image in prod:
            if image[:7] == 'Zdjęcie':
                entry['media'+str(counter)] = prod[image]
                counter += 1
                if counter == 13:
                    break
        
        entry['long description'] = prod['Opis']
        
        entry['brand'] = prod['Producent']
        
        entry['weight'] = prod['Waga']
        
        entry['lenght'] = prod['Długość']
        
        entry['width'] = prod['Szerokość']
        
        entry['height'] = prod['Wysokość']
        
        entry_to_save = []
        counter = 0 
        for x in entry:
            entry_to_save.append(entry[x])
            counter += 1
        root.append(entry_to_save)
        logging.info('Successfully appended entry ' + str(entry['product ID']))
    save_to_csv(root, new_name)
    

def save_to_csv(root, new_name):
    with open(new_name, 'w', newline='', encoding='utf-8') as output_file:
        counter1 = 0
        for x in keys:
            if counter1 == len(keys)-1:
                output_file.write(x+'\n')
            else:
                output_file.write(x+';')
            counter1 += 1
        
        dict_writer = csv.writer(output_file, delimiter=';')
        dict_writer.writerows(root)

def execute(old_name, new_name): 
    readOldCSV(old_name, new_name)